require 'watchdoge/webdriver_manager'
require 'watchdoge/version'
require 'watchdoge/configuration'
require 'watchdoge/cookie_pool'
require 'watchdoge/worker'
require 'watchdoge/notification'
require 'watchdoge/pixel_test'
require 'watchdoge/regression'
require 'watchdoge/rails/railtie' if defined?(Rails)
require 'watchdoge/rails/generator' if defined?(Rails)

module WatchDoge
  class << self
    def base_dir
      configuration.base_dir
    end

    def hooks
      configuration.hooks
    end

    def configure(&block)
      yield(configuration)
      configuration
    end

    def configuration
      @configuration ||= Configuration.new
    end

    def initialize!
      config_file = ENV['WATCHDOGE_CONFIG'] ||
        if defined?(Rails)
          "#{Rails.root}/config/watchdoge.rb"
        else
          "#{Dir.pwd}/watchdoge.rb"
        end

      load config_file
    end
  end
end
