require 'pry'
require 'net_http_ssl_fix'

require 'chunky_png'
require 'json'
require 'net/http'
require 'net/http/post/multipart'
require 'uri'

module WatchDoge
  module Notification
    class Base
      def initialize opt
        @message_queue = []
      end

      def push message
        @message_queue << message
      end

      def msg_size
        @message_queue.size
      end

      def flush
        @message_queue.each do |message|
          case message
          when String
            puts message
          when ChunkyPNG::Image
            File.write 'image.png', message.to_blob
          when WatchDoge::PixelTest
            File.write 'image.png', message.diff.to_blob
          end
        end

        @message_queue = []
      end
    end
  end
end
