# generating diff image of two input image

# usage:
#   diff_image = WatchDoge::PixelTest.diff(chunky_png_image, another_chunky_png_image)
#   WatchDoge::PixelTest.new diff_image, before:

# spec:
#   1. input only accept ChunkyPNG::Image, output image is also ChunkyPNG::Image
#   2. able to testing RGBA pixel by pixel. then blending with mask color if diff detected

# todo: should improve testing boundary for more accurate diff imagenot.

module WatchDoge
  class PixelTest
    def self.diff input_image, reference_image, opacity: 0.7, mask_base_color: "#F163FF"
      return nil if input_image.pixels.hash == reference_image.pixels.hash

      mask_color = mask_base_color.concat (opacity * 256).to_i.to_s(16).upcase

      dup_input_image = input_image.dup

      input_image.height.times do |y|
        pixels = input_image.row(y)

        if y >= reference_image.height
          pixels.each_with_index do |pixel, x|
            dup_input_image.compose_pixel(x, y, mask_color)
          end
        else
          reference_pixels = reference_image.row(y)

          next if (pixels.hash == reference_pixels.hash)

          pixels.each_with_index do |pixel, x|
            if pixels[x] != reference_pixels[x]
              dup_input_image.compose_pixel(x, y, reference_pixels[x])
              dup_input_image.compose_pixel(x, y, mask_color)
            end
          end
        end
      end

      dup_input_image
    end

    attr_reader :diff
    attr_reader :before
    attr_reader :after
    attr_reader :option

    def initialize input, reference, **kwargs
      @before = reference
      @after = input

      @option = kwargs

      @diff = self.class.diff input, reference
    end

    def diff?
      @diff
    end
  end
end
