# this file is part of Regression, mostly helpers methods

require 'digest'

module WatchDoge
  module Regression
    module Utils
      class << self
        def load_png input
          raise 'Invalid Input' unless input.respond_to? :length

          png_magic = ["89", "50", "4E", "47"]

          is_png_blob =
            (input.length > 3 && input[0..3].each_byte.map {|t| t.to_s(16).upcase} == png_magic)

          if is_png_blob
            ChunkyPNG::Image.from_blob input
          else
            ChunkyPNG::Image.from_file input
          end
        end

        def path_to_filename path
          path.gsub(/\//, '_')
        end

        def regression_dir
          WatchDoge.configuration.regression_dir
        end

        def scenarios_dir
          "#{regression_dir}/scenarios"
        end

        def reference_dir
          "#{regression_dir}/reference"
        end
      end
    end
  end
end
